<?php
/**
 * ApiV1IdentifyItems
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * ApiV1IdentifyItems Class Doc Comment
 *
 * @category Class
 * @description Describes a item which is to be \&quot;identifed\&quot; by the API (i.e. get an id by name)
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class ApiV1IdentifyItems implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = '_api_v1_identify_items';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'linkType' => 'string',
        'identifier' => 'string',
        'searchSections' => 'string[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'linkType' => null,
        'identifier' => null,
        'searchSections' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'linkType' => 'linkType',
        'identifier' => 'identifier',
        'searchSections' => 'searchSections'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'linkType' => 'setLinkType',
        'identifier' => 'setIdentifier',
        'searchSections' => 'setSearchSections'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'linkType' => 'getLinkType',
        'identifier' => 'getIdentifier',
        'searchSections' => 'getSearchSections'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const LINK_TYPE_PC = 'PC';
    public const LINK_TYPE_EMPLOYEE = 'EMPLOYEE';
    public const LINK_TYPE_CPU_TYPE = 'CPU_TYPE';
    public const LINK_TYPE_MANUFACTURER = 'MANUFACTURER';
    public const LINK_TYPE_OS = 'OS';
    public const SEARCH_SECTIONS_NAME = 'NAME';
    public const SEARCH_SECTIONS_EMAIL = 'EMAIL';
    public const SEARCH_SECTIONS_DOMAIN = 'DOMAIN';
    public const SEARCH_SECTIONS_SEARCH = 'SEARCH';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getLinkTypeAllowableValues()
    {
        return [
            self::LINK_TYPE_PC,
            self::LINK_TYPE_EMPLOYEE,
            self::LINK_TYPE_CPU_TYPE,
            self::LINK_TYPE_MANUFACTURER,
            self::LINK_TYPE_OS,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getSearchSectionsAllowableValues()
    {
        return [
            self::SEARCH_SECTIONS_NAME,
            self::SEARCH_SECTIONS_EMAIL,
            self::SEARCH_SECTIONS_DOMAIN,
            self::SEARCH_SECTIONS_SEARCH,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['linkType'] = $data['linkType'] ?? null;
        $this->container['identifier'] = $data['identifier'] ?? null;
        $this->container['searchSections'] = $data['searchSections'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getLinkTypeAllowableValues();
        if (!is_null($this->container['linkType']) && !in_array($this->container['linkType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'linkType', must be one of '%s'",
                $this->container['linkType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets linkType
     *
     * @return string|null
     */
    public function getLinkType()
    {
        return $this->container['linkType'];
    }

    /**
     * Sets linkType
     *
     * @param string|null $linkType Enum representing the \"link type\" of an entity to be identifed
     *
     * @return self
     */
    public function setLinkType($linkType)
    {
        $allowedValues = $this->getLinkTypeAllowableValues();
        if (!is_null($linkType) && !in_array($linkType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'linkType', must be one of '%s'",
                    $linkType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['linkType'] = $linkType;

        return $this;
    }

    /**
     * Gets identifier
     *
     * @return string|null
     */
    public function getIdentifier()
    {
        return $this->container['identifier'];
    }

    /**
     * Sets identifier
     *
     * @param string|null $identifier identifier (or name) of the entity. This will be used to search the entity id.
     *
     * @return self
     */
    public function setIdentifier($identifier)
    {
        $this->container['identifier'] = $identifier;

        return $this;
    }

    /**
     * Gets searchSections
     *
     * @return string[]|null
     */
    public function getSearchSections()
    {
        return $this->container['searchSections'];
    }

    /**
     * Sets searchSections
     *
     * @param string[]|null $searchSections searchSections
     *
     * @return self
     */
    public function setSearchSections($searchSections)
    {
        $allowedValues = $this->getSearchSectionsAllowableValues();
        if (!is_null($searchSections) && array_diff($searchSections, $allowedValues)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'searchSections', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['searchSections'] = $searchSections;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


